{------------------------------------------------------------------------------

  Unit otte_ctype provides OTTE witch basic locale-dependent charset
  routines: checking whether a char is a letter and turning it lowercase.
  Because OTTE is now working on single-byte chars, only single-byte
  encodings are supported.

  This unit was written for Windows. It is veery simplistic and don't
  support other locales than user's current setting.
  
                                --*--

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

------------------------------------------------------------------------------}
{$I otte_cfg.pas}
unit otte_ctype;

interface //===================================================================

type
  TotteCharProperty = array[char] of boolean;
  TotteCharAdjust   = array[char] of char;

function load_charmap(const charmap: ansistring;
                      var isalpha: TotteCharProperty;
		      var tolower: TotteCharAdjust): boolean;

implementation //==============================================================

uses
  Windows;

//-----------------------------------------------------------------------------
function load_charmap(const charmap: ansistring;
                      var isalpha: TotteCharProperty;
		      var tolower: TotteCharAdjust): boolean;
var
  c: char;
  resulting_isalpha: TotteCharProperty;
  resulting_tolower: TotteCharAdjust;

begin
  result := true;

  if charmap <> '' then result := false
  else
  try
    for c := #0 to #255 do begin
      resulting_isalpha[c] := IsCharAlpha(c);
      resulting_tolower[c] := c;
    end;

    CharLowerBuff(@resulting_tolower, sizeof(tolower));
  except
    result := false;
    exit;
  end;
  
  isalpha := resulting_isalpha;
  tolower := resulting_tolower;
end;

//-----------------------------------------------------------------------------
end.
